<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 02/07/12
 * Time: 11:50
 * To change this template use File | Settings | File Templates.
 */

class Registro13SalarioHomolognet extends RegistroHomolognet{


    const DECIMO_TERCEIRO = 'DecimoTerceiro';
    const DECIMO_TERCEIROS = 'DecimosTerceiros';
    const FALTAS_INJUSTIFICADAS = 'FaltasInjustificadas';
    const FALTA_INJUSTIFICADA = 'FaltaInjustificada';
    const ANO_MES = 'DTAnoMes';
    const FALTA = 'NRFalta';
    const ANO = 'NRAno';
    const DECIMO_TERCEIRO_PAGO = 'STPago';

    // Referente ao pagamento do 13 no ano.
    const SIM = 1;
    const NAO = 2;
    const PARCIAL = 3;

    const MESES_13_SALARIOS = 72;

    public $faltasHoras = Array(1 => '7.33', 2 => '14.66', 3 => '21.99', 4 => '29.32', 5 => '36.65', 6 => '43.98', 7 => '51.31',
                                8 => '58.64', 9 => '65.97', 10 => '73.30', 11 => '80.63', 12 => '87.96', 13 => '95.29', 14 => '102.62',
                                15 => '109.95', 16 => '117.28', 17 => '124.61', 18 => '131.94', 19 => '139.27', 20 => '146.60',
                                21 => '153.93', 22  => '161.26', 23 => '168.59', 24 => '175.92', 25 => '183.25', 26 => '190.58',
                                27 => '197.91', 28 => '205.24', 29 => '212.57', 30 => '219.90');

    private $_faltaInjustificada;
    private $_decimoTerceiro;
    private $_dtAux;


    public function setFaltaInjustificada($faltaInjustificada){
        $this->_faltaInjustificada .= $faltaInjustificada;
    }

    public function setDecimoTerceiro($decimoTerceiro){
//        $decimoTerceiro = self::DECIMO_TERCEIRO.';'.self::FALTAS_INJUSTIFICADAS.';'.$decimoTerceiro.'#;#;';
        $this->_decimoTerceiro .= $decimoTerceiro;
    }

    public function getDecimoTerceiro(){
        return $this->_decimoTerceiro;
    }

    public function geraRegistro13Salario($faltasInjustificadas, $decimosTerceiros){
        $this->_geraRegistro($faltasInjustificadas, $decimosTerceiros);
    }

    private function _geraRegistro($faltasInjustificadas, $decimosTerceiros){

        //@todo - Verificar se faltas injustificadas estiver vazio se

//        if ($faltasInjustificadas !== null) {

            // Atribuicao da tag Decimo Terceiro.
            $tag = self::DECIMO_TERCEIRO;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Atribuicao da tag Faltas Injustificadas.
            $tag = self::FALTAS_INJUSTIFICADAS;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Atribuicao de Tag ja calculada no metodo geraRegistroFaltasInjusticadas();
            foreach ($faltasInjustificadas as $faltas) {
                $this->geraRegistroFaltasInjusticadas($faltas["dtOcorrencia"], $faltas["referencia"]);
            }

            $tag = parent::CARACTER_FINALIZADOR;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            $tag = parent::CARACTER_FINALIZADOR;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);
//        }

        if ($decimosTerceiros !== null) {
            // Atribuicao de Tag ja calculada no metodo geraRegistroDecimoterceiro();
            foreach ($decimosTerceiros as $decimoTerceiroSalario) {
                $this->geraRegistroDecimoTerceiro($decimoTerceiroSalario["dtOcorrencia"], $decimoTerceiroSalario["dominio"]);
            }
        }

    }


    public function geraRegistroDecimoTerceiro($data, $realizouPagamento){
         // Atribuicao da tag Decimo Terceiro.
        $tag = self::DECIMO_TERCEIRO;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        // Campo 54 - tamanho 04 - Ano.
        $this->_atribuiAno($data);

        // Campo 55 - tamanho 01 - 13º Salários pagos (1 a 5).
        $this->_atribuiDecimoTerceiroPago($realizouPagamento);

        // @todo - No layout consta a existencia do campo de valor pago pelo 13  (campo 56) mas nao existe no arquivo xml gerado. Desconhecida a tag.

        $tag = parent::CARACTER_FINALIZADOR;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

//        $this->_decimoTerceiro .= $this->getLinhaRegistro();
    }


    public function geraRegistroFaltasInjusticadas($data, $faltas){

//        if (empty($data) !== false && empty($faltas) !== false) {

            $tag = self::FALTA_INJUSTIFICADA;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Campo 57 - tamanho 06 - Ano e Mes.
            $this->_atribuiAnoMes($data);

            // Campo 58 - tamanho 02 - Faltas Injustificadas por mês.
            $this->_atribuiFalta($faltas);

            $tag = parent::CARACTER_FINALIZADOR;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

//        }
//        $this->_faltaInjustificada .= $this->getLinhaRegistro();
    }

    
    private function _atribuiAnoMes($dado){
    /* · Informe de acordo com o seguinte formato: aaaamm
     * · Os campos 57 e 58 são correspondentes de forma combinada a cada uma das ocorrências nos últimos 72 meses incluindo o mês da rescisão.
     * · Este campo será de preenchimento obrigatório quando no campo de número 55 for informado domínio: “2 – Não” ou “3 – Parcial”.
     * · No caso de domínio: “1 – Pago”, este campo será obrigatório somente para o ano corrente.
     * · Para as situações de obrigatoriedade deste campo ele não poderá assumir valor nulo.
     */
         //$dado = 1;
         if (empty($dado) === false){

             $data = new TkDateTime($dado);
             $ano = $data->toString(TkDateTime::YEAR);
             $mes = $data->toString(TkDateTime::MONTH);
             unset($data);

             $tag = self::ANO_MES.parent::CARACTER_ATRIBUI;
             $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $ano.$mes, 6);
         }
    }

    private function _atribuiFalta($dado){
    /* · Este campo será de preenchimento obrigatório quando domínio: “2 – Não” ou “3 – Parcial” referente ao campo de número 55.
     * · No caso de domínio: 1 – Pago, este campo será obrigatório somente para o ano corrente.
     * · Este campo terá sua ocorrência condicionada e correspondente ao campo 57.
     * · Este campo será obrigatório se o campo 57 for informado. Para este caso, seu valor não poderá ser nulo.
     * · Para as situações de obrigatoriedade deste campo ele não poderá assumir valor nulo.
     */
         //$dado = 12;
         if ($dado !== null){
             if (strlen($dado) === 1){
                 $dado = '0'.$dado;
             }
             $tag = self::FALTA.parent::CARACTER_ATRIBUI;
             $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
         }
    }

    private function _atribuiAno($dado){
    /* · Informe de acordo com o seguinte formato: aaaa.
     * · Os campos 54 a 58 são correspondentes de forma combinada a cada uma das ocorrências nos últimos 5 anos anteriores
     *   ao ano da rescisão.
     * · O ano informado neste campo deve estar dentro da vigência do contrato de trabalho.
     */
         //$dado = 1;
         if (empty($dado) === false){

             $data = new TkDateTime($dado);
             $ano = $data->toString(TkDateTime::YEAR);
             unset($data);

             $tag = self::ANO.parent::CARACTER_ATRIBUI;
             $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $ano, 4);
         }
    }

    private function _atribuiDecimoTerceiroPago($dado){
    /* · Informe de acordo com o seguinte domínio: 1. SIM / 2. NÃO / 3. PARCIAL
     * · Este campo terá sua ocorrência condicionada e correspondente ao campo 54.
     */
         //$dado = 1;
         if (empty($dado) === false){
             $tag = self::DECIMO_TERCEIRO_PAGO.parent::CARACTER_ATRIBUI;
             $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
         }
    }






}
