/**
 * Transforma hora em formato decimal em hora no formato string.
 * 
 * @author Ederson Melquiades da Cunha <ederson@teknisa.com>
 *
 * @param P_HORADEC FLOAT Quantidade de horas decimal a ser convertida.
 *
 * @return VARCHAR2 String com a hora convertida no formato HH:MM. 
 *                  HH ter no mnimo 2 caracteres.
 *                  Exemplos: 
 *                  - de 1.5 para 01:30
 *                  - de -100.8 para -100:48
 */

FUNCTION HORADEC_HORACHAR (P_HORADEC FLOAT) 
RETURN VARCHAR2 IS 
   V_SINAL FLOAT;
   V_HORADEC FLOAT;
   V_SOMA_HORA FLOAT;
   V_MINUTOS VARCHAR2(2);
   V_HORACHAR VARCHAR2(4000);
BEGIN
   V_SINAL := 1;
   V_HORADEC := CASE WHEN P_HORADEC IS NULL THEN 0 ELSE ABS(P_HORADEC) END;
   IF P_HORADEC < 0 THEN
      V_SINAL := -1;
   END IF;
   IF ROUND((V_HORADEC-TRUNC(V_HORADEC))*60) >= 60 THEN
      -- ESTA SITUAO ACONTECE QUANDO A PARTE DECIMAL DA HORA  MUITO PERTO DE 1
      -- EXEMPLO 7.99999 RETORNAVA 07:60 AO INVS DE 08:00
      V_MINUTOS := LPAD(TO_CHAR(ROUND((V_HORADEC-TRUNC(V_HORADEC))*60) - 60), 2, '0');
      V_SOMA_HORA := 1;
   ELSE
      V_MINUTOS := LPAD(TO_CHAR(ROUND((V_HORADEC-TRUNC(V_HORADEC))*60)), 2, '0');
      V_SOMA_HORA := 0;
   END IF;   
   IF LENGTH(TO_CHAR(TRUNC(V_HORADEC))) >= 2 THEN 
      V_HORACHAR := TO_CHAR(TRUNC(V_HORADEC) + V_SOMA_HORA) || ':' || V_MINUTOS;
   ELSE
      V_HORACHAR := LPAD(TO_CHAR(TRUNC(V_HORADEC) + V_SOMA_HORA), 2, '0') || ':' || V_MINUTOS;
   END IF;  
   IF V_SINAL < 0 THEN
      V_HORACHAR := '-' || V_HORACHAR;
   END IF;
   RETURN (V_HORACHAR);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('HORADEC_HORACHAR','5.55.010'); END;
/