/* Tabela CLIEFILISAP: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela CLIEFILISAP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CLIEFILISAP utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_ADM_CLIEFILISAP
AFTER DELETE OR INSERT OR UPDATE
ON CLIEFILISAP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN

      IF :OLD.CDCLIENTESAP IS NOT NULL THEN
         V_DESC := V_DESC || 'Pagam=' || :OLD.CDCLIENTESAP;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.IDENTRSAIDOP || :OLD.CDTIPOOPER || :OLD.CDPRODUTO || :OLD.CDFILIAL || :OLD.IDFORMPGTSAP;
/*      V_CDFILLOGOPER := :OLD.CDFILIAL; */
   ELSE
      IF UPDATING THEN

         IF (:OLD.CDCLIENTESAP <> :NEW.CDCLIENTESAP) THEN
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.IDENTRSAIDOP || :OLD.CDTIPOOPER || :OLD.CDPRODUTO || :OLD.CDFILIAL || :OLD.IDFORMPGTSAP;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.IDENTRSAIDOP || :NEW.CDTIPOOPER || :NEW.CDPRODUTO || :NEW.CDFILIAL || :NEW.IDFORMPGTSAP;
      END IF;

      IF :NEW.CDCLIENTESAP IS NOT NULL THEN
         V_DESC := V_DESC || 'Pagam=' || :NEW.CDCLIENTESAP;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CLIEFILISAP',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_ADM_CLIEFILISAP','4.09.060'); END;
/

