/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_LEITO                                                    */
/* Tabela : LEITO                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                           	            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_LEITO'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_LEITO
  GO


CREATE TRIGGER DTULTATU_LEITO
ON LEITO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'LEITO', CDFILIAL, 'CDLEITO='+CDLEITO+';CDFILIAL='+CDFILIAL+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE LEITO
      SET DTULTATULEIT = GETDATE()
      FROM INSERTED
      WHERE
         (LEITO.CDLEITO    = INSERTED.CDLEITO   ) AND
         (LEITO.CDFILIAL   = INSERTED.CDFILIAL)
   END;
END;
GO



